#include <bits/stdc++.h>
#define ll long long
#define N 500005
using namespace std;
int n,Q;
int head[N],nxt[N*2],to[N*2],cnt;
void add(int u,int v){
	to[++cnt]=v;
	nxt[cnt]=head[u];
	head[u]=cnt;
	return ;
}
int dis[N],st[N][25];
void dfs(int u,int fa){
	int v;
	for(int i=head[u];i;i=nxt[i]){
		v=to[i];
		if(v==fa) continue;
		dis[v]=dis[u]+1;
		st[v][0]=u;
		dfs(v,u);
	}
	return ;
}
int lca(int u,int v){
	if(dis[u]<dis[v]) swap(u,v);
	for(int i=20;i>=0;i--)
		if(dis[st[u][i]]>=dis[v])
			u=st[u][i];
	if(u==v) return u;
	for(int i=20;i>=0;i--)
		if(st[u][i]!=st[v][i])
			u=st[u][i],v=st[u][i];
	return st[u][0];
}
int f[N][25];
int find(int l,int r){
	int res=l;
	for(int i=20;i>=0;i--){
		if(st[l][i]<=r){
			res=lca(res,f[l][i]);
			l=st[l][i];
		}
	} 
	return res;
}
signed main(){
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	scanf("%d",&n);
	int u,v;
	for(int i=1;i<n;i++){
		scanf("%d%d",&u,&v);
		add(u,v),add(v,u);
	}
	dis[1]=1;
	dfs(1,0);
	for(int j=1;j<=20;j++)
		for(int i=1;i<=n;i++)
			st[i][j]=st[st[i][j-1]][j-1];
	for(int i=1;i<=n;i++) f[i][0]=lca(i,st[i][0]);
	for(int j=1;j<=20;j++)
		for(int i=1;i<=n;i++)	
			f[i][j]=lca(f[i][j-1],f[st[i][j-1]][j-1]);
//	for(int i=1;i<=n;i++) for(int j=0;j<=20;j++) cout<<i<<' '<<j<<" "<<f[i][j]<<endl;
	scanf("%d",&Q);
	int l,r,k;
//	cout<<lca(1,n)<<endl;
	while(Q--){
		scanf("%d%d%d",&l,&r,&k);
		printf("%d\n",find(l,r));
	}
	return 0;
}
